const flash = /macromedia|shockwave|flash|.swf/;
const java = /java|.class/;
const tags = [ // tags to be removed
	"bgsound",
	"blink",
	"marquee",
	"noembed",
	"sound",
];
const url = "http://localhost/";

function main() {
	try {
		for (var i in tags) remove(tags[i]);
		purge("iframe", null,  "src",  url);
		purge("object", flash, "data", url);
		purge("embed",  flash, "src",  url);
		purge("app",    java,  "code", url);
		purge("applet", java,  "code", url);
	} catch(e) {alert(e);}
}

function remove(tagName) {
	var elements = document.evaluate("//" + tagName, document, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (elements == null) return;
	for (var i=0; i<elements.snapshotLength; i++) {
		var element = elements.snapshotItem(i);
		var parentNode = element.parentNode;
		parentNode.removeChild(element); // REMOVE ELEMENT
	}
}

function purge(tagName, regExp, replAttribute, replValue) {
	var elements = document.evaluate("//" + tagName, document, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (elements == null) return;
	for (var i=0; i<elements.snapshotLength; i++) {
		var element = elements.snapshotItem(i);
		if (regExp != null && !getOuterHTML(element).match(regExp)) continue;
		var parentNode = element.parentNode;
		var replacement = document.createElement(tagName); // create replacement
		var width = element.width + "";
		var height = element.height + "";
		replacement.setAttribute(replAttribute, replValue);
		replacement.style.display = "block";
		replacement.width = width;
		replacement.height = height;
		parentNode.replaceChild(replacement, element); // replace element
	}
}

function getOuterHTML(node) {
	var outerHTML = "";
	switch (node.nodeType) {
	case 1: // element-node
		outerHTML += "<" + node.nodeName;
		for (var i in node.attributes) {
			var item = node.attributes.item(i);
			outerHTML += " " + item.nodeName + "=";
			outerHTML += "\"" + item.nodeValue + "\"";
		}
		if (node.childNodes.length == 0) outerHTML += " />";
		else {
			outerHTML += ">";
			outerHTML += node.innerHTML;
			outerHTML += "</" + node.nodeName + ">"
		}
		break;
	}
	return outerHTML;
}

main();
